/* Virginia Tech Cognitive Radio Open Source Systems
 * Virginia Tech, 2009
 *
 * LICENSE INFORMATION GOES HERE
 */

/* This header contains commonly used data container structs in VT-CROSS
 * systems.
 */

#ifndef CONTAINERS_H
#define CONTAINERS_H


#include <netdb.h>
#include <stdint.h>
#include <string>


/* TODO
 *
 */
struct CE_Info {
    uint32_t numUtilities;
    uint32_t numParameters;
    uint32_t numObservables;
    uint32_t policy_engine;
    uint32_t policy_socket;
    uint32_t ce_socket;
};


/* TODO
 *
 */
struct Utility {
    std::string name;
    std::string units;
    std::string goal;
    float target;
    float value;
};


/* TODO
 *
 */
struct Affect {
    Utility *u;
    std::string relation;
};


/* TODO
 *
 */
struct Parameter {
    std::string name;
    std::string units;
    float min;
    uint32_t numAffects;
    Affect affection_list[10];
    float max;
    float step;
    float value;
};


/* TODO
 *
 */
struct Observable {
    std::string name;
    Affect affection_list[10];
    uint32_t numAffects;
    float value;
};


/* Contains information regarding a remote component in a VTCROSS system.  Note
 * that this information is independent of component type, but technically will
 * only ever be the SML or shell.
 *
 * TODO I'm not 100% certain I'm doing this in the most efficient way.  Need
 * someone to look it over.
 */
struct RemoteComponent {
    struct hostent *server;
    std::string serverName;
    int32_t serverPort;
    int32_t socketFD;
};

#endif
